# from http://wingide.com/pipermail/wingide-users/2002-June/001144.html

import pygtk
pygtk.require('2.0')
import gtk
import os

class FileSelection(gtk.FileSelection):
    "Taken from pygtk, and made better"
    def __init__(self, title='Open', modal=gtk.FALSE, file_required=1):
        gtk.FileSelection.__init__(self)
        self.file_required = file_required
        self.set_title(title)
        self.connect('destroy', self.quit)
        self.connect('delete_event', self.quit)
        if modal:
            self.grab_add()
        self.cancel_button.connect('clicked', self.quit)
        self.ok_button.connect('clicked', self.ok)
        self.return_filename = None
    
    def quit(self, *args):
        # print "quit"
        self.hide()
        self.destroy()
        gtk.main_quit()
    
    def ok(self, *args):
        # print "OK"
        filename = self.get_filename()
        filename = os.path.normpath(filename)
        print "fname: %s" % filename
        if self.file_required and os.path.isdir(filename):
            if filename[-1:] != '/': filename += '/'
            self.set_filename(filename)
        else:
            self.return_filename = filename
            self.quit()
            
def select_file(title='Open', modal=gtk.FALSE, reqfile=0):
    "Taken from pygtk and made better"
    win = FileSelection(title, modal, reqfile)
    win.show()
    gtk.main()
    return win.return_filename
